/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#line 541
#ifdef HAVE_CONFIG_H
#line 541
# include <config.h>
#line 541
#endif
#line 541
#include <sys/types.h>
#line 541

#line 541
#include "mailfromd.h"
#line 541
#include "prog.h"
#line 541
#include "builtin.h"
#line 541

#line 520 "sa.bi"
static mu_debug_handle_t debug_handle;
#line 541 "sa.bi"

#line 742 "../../src/builtin/snarf.m4"

#line 1 "sa.bi"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2006, 2007, 2008, 2009, 2010, 2011 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <string.h>
#include <signal.h>

static size_t sa_score_loc
#line 25 "sa.bi"
;
static size_t sa_threshold_loc
#line 26 "sa.bi"
;
static size_t sa_keywords_loc
#line 27 "sa.bi"
;
static size_t clamav_virus_name_loc
#line 28 "sa.bi"
;

static int
set_xscript(mu_stream_t *pstr)
{
	int rc;
	mu_stream_t tstr = *pstr;
	
	if (mu_debug_level_p(debug_handle, MU_DEBUG_PROT)) {
		int rc;
		mu_stream_t dstr;

		rc = mu_dbgstream_create(&dstr, MU_DIAG_DEBUG);
		if (rc)
			mu_error(_("cannot create debug stream; "
				   "transcript disabled: %s"),
				 mu_strerror(rc));
		else {
			rc = mu_xscript_stream_create(pstr, tstr, dstr, NULL);
			mu_stream_unref(dstr);
			if (rc)
				mu_error(_("cannot create transcript "
					   "stream: %s"),
					 mu_strerror(rc));
			else
				mu_stream_unref(tstr);
		}
	}
	return rc;
}

static int
spamd_send_stream(mu_stream_t out, mu_stream_t in)
{
  int rc;
  struct mu_buffer_query newbuf, oldbuf;
  int bufchg = 0;
  int xlev;
  int xlevchg = 0;
  
  /* Ensure effective transport buffering */
  if (mu_stream_ioctl(out, MU_IOCTL_TRANSPORT_BUFFER,
		      MU_IOCTL_OP_GET, &oldbuf) == 0) {
	  newbuf.type = MU_TRANSPORT_OUTPUT;
	  newbuf.buftype = mu_buffer_full;
	  newbuf.bufsize = 64*1024;
	  mu_stream_ioctl(out, MU_IOCTL_TRANSPORT_BUFFER, MU_IOCTL_OP_SET, 
			  &newbuf);
	  bufchg = 1;
  }

  if (!mu_debug_level_p(debug_handle, MU_DEBUG_TRACE9)) {
	  /* Mark out the following data as payload */
	  xlev = MU_XSCRIPT_PAYLOAD;
	  if (mu_stream_ioctl(out, MU_IOCTL_XSCRIPTSTREAM,
			      MU_IOCTL_XSCRIPTSTREAM_LEVEL, &xlev) == 0)
		  xlevchg = 1;
  }
  
  rc = mu_stream_copy(out, in, 0, NULL);

  /* Restore prior transport buffering and xscript level */
  if (bufchg)
    mu_stream_ioctl(out, MU_IOCTL_TRANSPORT_BUFFER, MU_IOCTL_OP_SET,  &oldbuf);
  if (xlevchg)
    mu_stream_ioctl(out, MU_IOCTL_XSCRIPTSTREAM,
		    MU_IOCTL_XSCRIPTSTREAM_LEVEL, &xlev);
  return rc;
}


static int
spamd_connect(eval_environ_t env, mu_stream_t *pstream,
	      const char *host, int port)
{
	int rc;
	char *fname;
	mu_stream_t tstr, istr, ostr;
	
	if (port) {
		fname = "mu_tcp_stream_create";
		rc = mu_tcp_stream_create(&tstr, host, port, MU_STREAM_RDWR);
	} else {
		fname = "mu_socket_stream_create";
		rc = mu_socket_stream_create(&tstr, host, MU_STREAM_RDWR);
	}

		if (!(rc == 0))
#line 115
		(
#line 115
	env_throw_bi(env, mfe_failure, NULL, "%s: %s",fname,mu_strerror(rc))
#line 115
)
#line 117
;

	mu_stream_set_buffer (tstr, mu_buffer_line, 0);

	rc = mu_filter_create(&istr, tstr, "CRLF",
			      MU_FILTER_DECODE, MU_FILTER_READ);
	if (rc) {
		mu_stream_unref(tstr);
		(
#line 125
	env_throw_bi(env, mfe_failure, NULL, "%s input filter: %s",fname,mu_strerror(rc))
#line 125
);
#line 128
	}
	mu_stream_set_buffer(istr, mu_buffer_line, 0);
	
	rc = mu_filter_create(&ostr, tstr, "CRLF",
			      MU_FILTER_ENCODE, MU_FILTER_WRITE);
	if (rc) {
		mu_stream_unref(tstr);
		(
#line 135
	env_throw_bi(env, mfe_failure, NULL, "%s output filter: %s",fname,mu_strerror(rc))
#line 135
);
#line 138
	}
	mu_stream_set_buffer(ostr, mu_buffer_line, 0);
	mu_stream_unref(tstr);
	
	rc = mu_iostream_create(&tstr, istr, ostr);
	mu_stream_unref(istr);
	mu_stream_unref(ostr);
		if (!(rc == 0))
#line 145
		(
#line 145
	env_throw_bi(env, mfe_failure, NULL, "I/O stream: %s",mu_strerror(rc))
#line 145
)
#line 147
;
	mu_stream_set_buffer(tstr, mu_buffer_line, 0);
	set_xscript(&tstr);
	*pstream = tstr;
	return rc;
}

static int
spamd_get_line(mu_stream_t stream, char **pbuffer, size_t *psize)
{
	int rc = mu_stream_getline(stream, pbuffer, psize, NULL);
	if (rc == 0)
		mu_rtrim_class (*pbuffer, MU_CTYPE_SPACE);
	return rc;
}

#define char_to_num(c) (c-'0')

static void
decode_float(long *vn, char *str, int digits)
{
	long v;
	size_t frac = 0;
	size_t base = 1;
	int i;
	int negative = 0;
  
	for (i = 0; i < digits; i++)
		base *= 10;
  
	v = strtol(str, &str, 10);
	if (v < 0) {
		negative = 1;
		v = - v;
	}
  
	v *= base;
	if (*str == '.') {
		for (str++, i = 0; *str && i < digits; i++, str++)
			frac = frac * 10 + char_to_num (*str);
		if (*str) {
			if (char_to_num(*str) >= 5)
				frac++;
		}
		else
			for (; i < digits; i++)
				frac *= 10;
	}
	*vn = v + frac;
	if (negative)
		*vn = - *vn;
}

static int
decode_boolean (char *str)
{
	if (strcasecmp (str, "true") == 0)
		return 1;
	else if (strcasecmp (str, "false") == 0)
		return 0;
	/*else?*/
	return 0;
}

typedef RETSIGTYPE (*signal_handler_fn)(int);

static signal_handler_fn
set_signal_handler (int sig, signal_handler_fn h)
{
#ifdef HAVE_SIGACTION
	struct sigaction act, oldact;
	act.sa_handler = h;
	sigemptyset (&act.sa_mask);
	act.sa_flags = 0;
	sigaction (sig, &act, &oldact);
	return oldact.sa_handler;
#else
	return signal (sig, h);
#endif
}

static int got_sigpipe;

static RETSIGTYPE
sigpipe_handler (int sig)
{
	got_sigpipe = 1;
}

mu_stream_t
open_connection(eval_environ_t env, char *urlstr, char **phost)
{
	char *path = NULL;
	short port = 0;
	mu_stream_t str = NULL;
	int rc;
	
	if (urlstr[0] == '/') {
		path = strdup(urlstr);
		if (!path)
			runtime_error(env, _("not enough memory"));
	} else {
		const char *buf;
		mu_url_t url = NULL;
		
		rc = mu_url_create(&url, urlstr);
		if (rc)
			(
#line 254
	env_throw_bi(env, mfe_failure, NULL, _("cannot create URL from `%s': %s"),urlstr,mu_strerror(rc))
#line 254
);
#line 257
		
		if (rc = mu_url_sget_scheme(url, &buf)) {
			mu_url_destroy(&url);
			(
#line 260
	env_throw_bi(env, mfe_url, NULL, _("%s: cannot get scheme: %s"),urlstr,mu_strerror(rc))
#line 260
);
#line 263
		}

		if (strcmp(buf, "file") == 0
		    || strcmp(buf, "socket") == 0) {
			if (rc = mu_url_aget_path(url, &path)) {
				(
#line 268
	env_throw_bi(env, mfe_url, NULL, _("%s: cannot get path: %s"),urlstr,mu_strerror(rc))
#line 268
);
#line 271
			}
		} else if (strcmp(buf, "tcp") == 0) {
			unsigned n;
			
			if (rc = mu_url_get_port(url, &n)) {
				mu_url_destroy(&url);
				(
#line 277
	env_throw_bi(env, mfe_url, NULL, _("%s: cannot get port: %s"),urlstr,mu_strerror(rc))
#line 277
);
#line 280
			}

			if (n == 0 || (port = n) != n) {
				mu_url_destroy(&url);
				(
#line 284
	env_throw_bi(env, mfe_range, NULL, _("port out of range: %u"),n)
#line 284
);
#line 287
			}
			
			if (rc = mu_url_aget_host(url, &path)) {
				mu_url_destroy(&url);
				(
#line 291
	env_throw_bi(env, mfe_url, NULL, _("%s: cannot get host: %s"),urlstr,mu_strerror(rc))
#line 291
);
#line 294
			}
		} else
			(
#line 296
	env_throw_bi(env, mfe_url, NULL, _("invalid URL: %s"),buf)
#line 296
);
#line 298

		mu_url_destroy(&url);
	}

	rc = spamd_connect(env, &str, path, port);
	
	if (rc == 0 && phost) {
		if (port)
			*phost = path;
		else
			*phost = NULL;
	}
	return str;
}	



	
void
#line 316
bi_sa(eval_environ_t env)
#line 316

#line 316

#line 316 "sa.bi"
{
#line 316
	  mu_stream_t mstr;
#line 316

#line 316
	
#line 316

#line 316
long __bi_argcnt;
#line 316
char * MFL_DATASEG urlstr;
#line 316
        long  prec;
#line 316
        long  report;
#line 316
        
#line 316
get_string_arg(env, 1, &urlstr);
#line 316
        get_numeric_arg(env, 2, &prec);
#line 316
        get_numeric_arg(env, 3, &report);
#line 316
        
#line 316
get_numeric_arg(env, 0, &__bi_argcnt);
#line 316
        adjust_stack(env, __bi_argcnt + 1);
#line 316

#line 316
{
#line 316
	  int rc = env_get_stream(env,&mstr);
#line 316
	  	if (!(rc == 0))
#line 316
		(
#line 316

#line 316
	mu_stream_unref(mstr),
#line 316
	env_throw_bi(env, mfe_failure, "sa", "cannot obtain capture stream reference: %s",mu_strerror(rc))
#line 316
)
#line 316
;
#line 316
	}
#line 316
	if (builtin_module_trace(BUILTIN_IDX_sa))
#line 316
		prog_trace(env, "sa %s %lu %lu",urlstr, prec, ((__bi_argcnt > 2) ? report : 0));;
#line 316

{
	mu_off_t msize;
	mu_stream_t ostr;
	signal_handler_fn handler;
	char *buffer = NULL;
	size_t bufsize = 0;
	size_t n;
	char version_str[19];
	char spam_str[6], score_str[21], threshold_str[21];
	long version;
	int result;
	long score, threshold;
	int report_mode = ((__bi_argcnt > 2) ? report : 0);
	int rc;
	
	rc = mu_stream_size(mstr, &msize);
		if (!(rc == 0))
#line 333
		(
#line 333

#line 333
	mu_stream_unref(mstr),
#line 333
	env_throw_bi(env, mfe_failure, "sa", "mu_stream_size: %s",mu_strerror (rc))
#line 333
)
#line 336
;
	
	ostr = open_connection(env, urlstr, NULL);
		
	msize += env_get_line_count(env);
	mu_stream_printf(ostr,
			   report_mode ? "REPORT SPAMC/1.2\n"
			               : "SYMBOLS SPAMC/1.2\n");
	mu_stream_printf(ostr, "Content-length: %lu\n",
			 (unsigned long) msize);
	/*FIXME: spamd_send_command(ostr, "User: %s", ??) */
	got_sigpipe = 0;
	handler = set_signal_handler(SIGPIPE, sigpipe_handler);
	mu_stream_write(ostr, "\n", 1, NULL);
	if (rc = spamd_send_stream(ostr, mstr)) {
		mu_stream_destroy(&ostr);
		(
#line 352

#line 352
	mu_stream_unref(mstr),
#line 352
	env_throw_bi(env, mfe_failure, "sa", _("send stream failed: %s"),mu_strerror (rc))
#line 352
);
#line 355
	}
	mu_stream_shutdown(ostr, MU_STREAM_WRITE);
	set_signal_handler(SIGPIPE, handler);
	
	spamd_get_line(ostr, &buffer, &bufsize);
	if (got_sigpipe) {
		mu_stream_destroy(&ostr);
		free(buffer);
		(
#line 363

#line 363
	mu_stream_unref(mstr),
#line 363
	env_throw_bi(env, mfe_failure, "sa", _("remote side has closed connection"))
#line 363
);
	}

	if (sscanf(buffer, "SPAMD/%18s %d %*s", version_str, &result) != 2) {
		mu_stream_destroy(&ostr);
		free(buffer);
		(
#line 369

#line 369
	mu_stream_unref(mstr),
#line 369
	env_throw_bi(env, mfe_failure, "sa", _("spamd responded with bad string '%s'"),buffer)
#line 369
);
#line 372
	}

	decode_float(&version, version_str, 1);
	if (version < 10) {
		mu_stream_destroy(&ostr);
		free(buffer);
		(
#line 378

#line 378
	mu_stream_unref(mstr),
#line 378
	env_throw_bi(env, mfe_failure, "sa", _("unsupported SPAMD version: %s"),version_str)
#line 378
);
#line 381
	}

	if (result) {
		mu_stream_destroy(&ostr);
		free(buffer);
		(
#line 386

#line 386
	mu_stream_unref(mstr),
#line 386
	env_throw_bi(env, mfe_failure, "sa", "%s",buffer)
#line 386
);
	}
	
	spamd_get_line(ostr, &buffer, &bufsize);
	if (sscanf (buffer, "Spam: %5s ; %20s / %20s",
		    spam_str, score_str, threshold_str) != 3) {
		mu_stream_destroy(&ostr);
		free(buffer);
		(
#line 394

#line 394
	mu_stream_unref(mstr),
#line 394
	env_throw_bi(env, mfe_failure, "sa", _("spamd responded with bad Spam header '%s'"),buffer)
#line 394
);
#line 397
	}

	result = decode_boolean(spam_str);
	decode_float(&score, score_str, prec);
	decode_float(&threshold, threshold_str, prec);

	*env_data_ref(env, sa_score_loc) = (STKVAL) (score);
	*env_data_ref(env, sa_threshold_loc) = (STKVAL) (threshold);

	/* Skip newline */
	spamd_get_line(ostr, &buffer, &bufsize);
	if (report_mode) {
		heap_obstack_begin(env);
		while (mu_stream_getline(ostr, &buffer, &bufsize, &n) == 0
		       && n > 0) 
			heap_obstack_grow(env, buffer, n);
		do { char __c = 0; heap_obstack_grow(env, &__c, 1); } while(0);
		*env_data_ref(env, sa_keywords_loc) = (STKVAL) (heap_obstack_finish(env));
	} else {
		/* Read symbol list */
		spamd_get_line(ostr, &buffer, &bufsize);

		
#line 419
{ size_t __off;
#line 419
  const char *__s = buffer;
#line 419
  if (__s)
#line 419
     strcpy((char*)env_data_ref(env, __off = heap_reserve(env, strlen(__s) + 1)), __s);
#line 419
  else
#line 419
     __off = 0;
#line 419
  *env_data_ref(env, sa_keywords_loc) = (STKVAL) (__off); }
#line 419
;
	
		while (mu_stream_getline(ostr, &buffer, &bufsize, &n) == 0
		       && n > 0) 
			/* Drain input */;
	}
  	mu_stream_destroy(&ostr);
	free(buffer);
	
#line 427
do {
#line 427
  push(env, (STKVAL) (result));
#line 427
  goto endlab;
#line 427
} while (0);
}
endlab:
#line 429

#line 429
	mu_stream_unref(mstr);
#line 429
	return;
#line 429
}

static int
clamav_open_data_stream(mu_stream_t *retstr, const char *host, unsigned port)
{
	mu_stream_t tstr, dstr;
	int rc = mu_tcp_stream_create(&dstr, host, port, 0);
	if (rc)
		return rc;
	rc = mu_filter_create(&tstr, dstr, "CRLF",
			      MU_FILTER_ENCODE, MU_FILTER_WRITE);
	mu_stream_unref(dstr);
	if (rc)
		return rc;
	set_xscript(&tstr);
	*retstr = tstr;
	return 0;
}
	


	
void
#line 451
bi_clamav(eval_environ_t env)
#line 451

#line 451

#line 451 "sa.bi"
{
#line 451
	  mu_stream_t mstr;
#line 451

#line 451
	
#line 451

#line 451

#line 451
char * MFL_DATASEG urlstr;
#line 451
        
#line 451
get_string_arg(env, 0, &urlstr);
#line 451
        
#line 451

#line 451
        adjust_stack(env, 1);
#line 451

#line 451
{
#line 451
	  int rc = env_get_stream(env,&mstr);
#line 451
	  	if (!(rc == 0))
#line 451
		(
#line 451

#line 451
	mu_stream_unref(mstr),
#line 451
	env_throw_bi(env, mfe_failure, "clamav", "cannot obtain capture stream reference: %s",mu_strerror(rc))
#line 451
)
#line 451
;
#line 451
	}
#line 451
	if (builtin_module_trace(BUILTIN_IDX_sa))
#line 451
		prog_trace(env, "clamav %s",urlstr);;
#line 451

{
	mu_stream_t cstr, dstr;
	char *buffer = NULL;
	size_t bufsize = 0;
	char *host;
	unsigned short port;
	int rc;
	signal_handler_fn handler;
	char *p;

	cstr = open_connection(env, urlstr, &host);

	mu_stream_printf(cstr, "STREAM\n");
	spamd_get_line(cstr, &buffer, &bufsize);
	if (sscanf(buffer, "PORT %hu", &port) != 1) {
		mu_stream_destroy(&cstr);
		free(buffer);
		(
#line 469

#line 469
	mu_stream_unref(mstr),
#line 469
	env_throw_bi(env, mfe_failure, "clamav", _("bad response from clamav: expected `PORT' but found `%s'"),buffer)
#line 469
);
#line 472
	}

	if (!host) 
		host = strdup("127.0.0.1"); /* FIXME */
	rc = clamav_open_data_stream(&dstr, host, port);
	free(host);
	if (rc) {
		mu_stream_destroy(&cstr);
		(
#line 480

#line 480
	mu_stream_unref(mstr),
#line 480
	env_throw_bi(env, mfe_failure, "clamav", "mu_tcp_stream_create: %s",mu_strerror(rc))
#line 480
);
#line 483
	}
	
	handler = set_signal_handler(SIGPIPE, sigpipe_handler);
	rc = spamd_send_stream(dstr, mstr);
	mu_stream_shutdown(dstr, MU_STREAM_WRITE);
	mu_stream_destroy(&dstr);
	set_signal_handler(SIGPIPE, handler);
	if (rc) {
		mu_stream_destroy(&cstr);
		free(buffer);
		(
#line 493

#line 493
	mu_stream_unref(mstr),
#line 493
	env_throw_bi(env, mfe_failure, "clamav", _("sending to stream failed: %s"),mu_strerror (rc))
#line 493
);
#line 496
	}

	rc = spamd_get_line(cstr, &buffer, &bufsize);
	mu_stream_destroy(&cstr);
		if (!(rc == 0))
#line 500
		(
#line 500

#line 500
	mu_stream_unref(mstr),
#line 500
	env_throw_bi(env, mfe_failure, "clamav", _("error reading clamav response: %s"),mu_strerror(rc))
#line 500
)
;

	p = strrchr(buffer, ' ');
        	if (!(p))
#line 504
		(
#line 504

#line 504
	mu_stream_unref(mstr),
#line 504
	env_throw_bi(env, mfe_failure, "clamav", _("unknown clamav response: %s"),buffer)
#line 504
)
;
	++p;
	if (strncmp(p, "OK", 2) == 0)
		rc = 0;
	else if (strncmp(p, "FOUND", 5) == 0) {
		char *s;
			
		*--p = '\0';
		s = strrchr(buffer, ' ');
		if (!s)
			s = buffer;
		else
			s++;
		
#line 518
{ size_t __off;
#line 518
  const char *__s = s;
#line 518
  if (__s)
#line 518
     strcpy((char*)env_data_ref(env, __off = heap_reserve(env, strlen(__s) + 1)), __s);
#line 518
  else
#line 518
     __off = 0;
#line 518
  *env_data_ref(env, clamav_virus_name_loc) = (STKVAL) (__off); }
#line 518
;

		
#line 520 "sa.bi"

#line 520
mu_debug(debug_handle, 2,("%sclamav found %s",
		          mailfromd_msgid(env_get_context(env)), s));
#line 523
		rc = 1;
	} else if (strncmp(p, "ERROR", 5) == 0) {
		/* FIXME: mf code */
		free(buffer);
		(
#line 527

#line 527
	mu_stream_unref(mstr),
#line 527
	env_throw_bi(env, mfe_failure, "clamav", _("clamav error: %s"),buffer)
#line 527
);
#line 530
	} else {
		free(buffer);
		(
#line 532

#line 532
	mu_stream_unref(mstr),
#line 532
	env_throw_bi(env, mfe_failure, "clamav", _("unknown clamav response: %s"),buffer)
#line 532
);
#line 535
	}
	free(buffer);
	
#line 537
do {
#line 537
  push(env, (STKVAL) (rc));
#line 537
  goto endlab;
#line 537
} while (0);
}
endlab:
#line 539

#line 539
	mu_stream_unref(mstr);
#line 539
	return;
#line 539
}


#line 541
void
#line 541
sa_init_builtin()
#line 541
{
#line 541
		debug_handle = mu_debug_register_category("bi_sa");
#line 541

#line 541
	#line 25 "sa.bi"
	builtin_variable_install("sa_score", dtype_number, SYM_VOLATILE, &sa_score_loc);
#line 26 "sa.bi"
	builtin_variable_install("sa_threshold", dtype_number, SYM_VOLATILE, &sa_threshold_loc);
#line 27 "sa.bi"
	builtin_variable_install("sa_keywords", dtype_string, SYM_VOLATILE, &sa_keywords_loc);
#line 28 "sa.bi"
	builtin_variable_install("clamav_virus_name", dtype_string, SYM_VOLATILE, &clamav_virus_name_loc);
#line 316 "sa.bi"
va_builtin_install_ex("sa", bi_sa, STATMASK(smtp_state_eom), dtype_number, 3, 1, MFD_BUILTIN_CAPTURE|0, dtype_string, dtype_number, dtype_number);
#line 451 "sa.bi"
va_builtin_install_ex("clamav", bi_clamav, STATMASK(smtp_state_eom), dtype_number, 1, 0, MFD_BUILTIN_CAPTURE|0, dtype_string);

#line 541 "sa.bi"
	
#line 541
}
#line 541 "sa.bi"

#line 541


#line 736 "../../src/builtin/snarf.m4"

#line 736

